mcs(1)

NAME
mcs - Mono Compiler Suite.

SYNOPSIS
mcs [option] [source-files]

DESCRIPTION
mcs is the Mono C# compiler, an implementation of the ECMA-334 language specification. You can pass one or more options to drive the compiler, and a set of source files. Extra options or arguments can be provided in a response file. Response files are referenced by prepending the @ symbol to the response file name.

C# source files must end with a ".cs" extension. Compilation of C# source code requires all the files that make up a library, module or executable to be provided on the command line. There is no support for partial compilation. To achieve the benefits of partial compilation, you should compile programs into their own assemblies, and later reference them with the "-r" flag.

The Mono C# compiler generates images (.exe files) that contain CIL byte code that can be executed by any system that implements a Common Language Infrastructure virtual machine such as the Microsoft .NET runtime engine on Windows or the Mono runtime engine on Unix systems. Executables are not bound to a specific CPU or operating system.

OPTIONS

--about
    Displays information about the Mono C# compiler

--checked
    Sets the default compilation mode to `checked'. This makes all the math operations checked (the default is unchecked).

--define SYMBOL
    Defines a symbol named SYMBOL. This can be tested in the source code by the pre-processor.

--debug or -g
    Generate debugging information.

--fatal
    This is used for debugging the compiler. This makes the error emission generate an exception that can be caught by a debugger.

--stacktrace
    Generates a stack trace at the time the error is reported, useful for debugging the compiler.

-L PATH
    Directs the compiler to look for libraries in the specified path. Multiple paths can be provided.

--nostdlib
    Use this flag if you want to compile the core library. This makes the compiler load its internal types from the assembly being compiled.

--noconfig
    Disables the default compiler configuration to be loaded. The compiler by default has references to the system assemblies.

--nowarn XXX
    Makes the compiler ignore warning XXX.

-o FNAME
    Names the output file to be generated.

--optimize
    Turns on optimizations in the compiler.

--parse
    Used for benchmarking. The compiler will only parse its input files.

--probe X L
    Probes for the code to generate an error named `X' in line `L'. This is only used by the test suite.

/linkres:RESOURCE
    Links to the given resources

--recurse PATTERN
    Does recursive compilation using the specified pattern. In Unix the shell will perform globbing, so you migth want to use it like this:

		bash$ mcs --recurse '*.cs'

--linkres FILE
    Links FILE as a resource of the resulting assembly.

--target KIND
    Used to specify the desired target. The possible values are: exe, winexe, library and module.

--timestamp
    Another debugging flag. Used to display the times at various points in the compilation process.

--unsafe
    Enables compilation of unsafe code.

--werror
    Treat warnings as errors.

--wlevel LEVEL
    Sets the warning level. 0 is the lowest warning level, and 4 is the highest. The default is 2.

-r ASSEMBLY
    Reference the named assembly. Use this to use classes from the named assembly in your program. The assembly will be loaded from either the system directory where all the assemblies live, or from the path explicitly given with the -L option.

-v  Debugging. Turns on verbose yacc parsing.

--  Use this to stop option parsing, and allow option-looking parameters to be passed on the command line.

SPECIAL DEFINES
The TRACE and DEBUG defines have a special meaning to the compiler.

By default calls to methods and properties in the System.Diagnostics.Trace class are not generated unless the TRACE symbol is defined (either through a "#define TRACE") in your source code, or by using the --define TRACE in the command line.

By default calls to methods and properties in the System.Diagnostics.Debug class are not generated unless the DEBUG symbol is defined (either through a "#define DEBUG") in your source code, or by using the --define DEBUG in the command line.

Note that the effect of defining TRACE and DEBUG is a global setting, even if they are only defined in a single file.

DEBUGGING SUPPORT
When use the "--debug" or "-g" flag, MCS will create an assembler file FILE-debug.s containing debugging information where FILE is the name of the generated assembly. You need to run this file through the assembler to get a object file FILE-debug.o. See mono's "--dwarf-plus" argument for details on how to use this file.

NOTES
During compilation the MCS compiler defines the __MonoCS__ symbol, this can be used by pre-processor instructions to compile Mono C# compiler specific code.

AUTHORS
The Mono C# Compiler was written by Miguel de Icaza and Ravi Pratap at Ximian.

LICENSE
The Mono Compiler Suite is released under the terms of the GNU GPL. Please read the accompanying `COPYING' file for details. Alternative licenses are available from Ximian.

SEE ALSO
mono(1), mint(1)

BUGS
To report bugs in the compiler, you can use `bug-buddy', or you can file bug reports in our bug tracking system: http://bugzilla.ximian.com.

MAILING LIST
The Mono Mailing List is available at: mono-list-request@ximian.com

MORE INFORMATION
The Mono C# compiler is developed by Ximian, Inc (http://www.ximian.com) (http://www.ximian.com) and is based on the ECMA C# language standard available here: http://www.ecma.ch/ecma1/STAND/ecma-334.htm